/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ft_vdprintf.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angoulem      +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/10/12 14:34:28 by cchauvet          #+#    #+#             */
/*   Updated: 2022/10/12 16:47:32 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ft_printf.h"

static int	ft_dprintseg(int fd, const char *str)
{
	int	i;

	i = 0;
	while (str[i] != '\0' && ft_skipflag(str + i) == 0)
		ft_putchar_fd(fd, str[i++]);
	return (i);
}

int	ft_vdprintf(int fd, const char *format, va_list va)
{
	int			i;
	int			upi;

	i = 0;
	while (format[0] != 0)
	{
		if (ft_skipflag(format) == 0)
		{
			upi = ft_dprintseg(fd, format);
			format += upi;
			i += upi;
		}
		else
		{
			upi = ft_dprintflag(fd, format, va);
			if (upi == -1)
				return (-1);
			format += ft_skipflag(format);
			i += upi;
		}
	}
	return (i);
}
